@i ../copyright.w

@* u\_strnappend.

Concatenates two strings, taking maximum of |n| characters of the second, and
allocating any memory needed in the first to hold the result.

@c

#include <unicode.h>

Uchar*
u_strnappend(Uchar **dest, const Uchar *src, size_t n){
	int src_len, dest_len;

        if(src){
		src_len = uni_strlen(src);
                if (src_len>n) src_len=n;
		dest_len = uni_strlen(*dest);

		if(dest_len)
			src_len--; /* exclude BOM */

		*dest = realloc(*dest, ((dest_len + src_len + 1)
					 	* sizeof(Uchar)));

		if(!*dest){
			return;
		}

		if(dest_len)
			src++; /* remove BOM */
		while(src_len--){
			dest[0][dest_len++] = *src++;
		}

		dest[0][dest_len] = '\0';
	}

	return *dest;
}

@* Index.
