@i ../copyright.w

@* uni\_strappend.

Concatenates two strings, allocating any memory needed in the first
to hold the second. Returns NULL on memory allocation error, or else first
string (i.e. contents of dest variable).

@c

#include <unicode.h>

Uchar*
uni_strappend(Ufunctions *ufunct, Uchar **dest, const Uchar *src){
	int src_len, dest_len;

	ufunct->error = U_ERR_NONE;

        if(src){
		src_len = uni_strlen(src);
		dest_len = uni_strlen(*dest);

		if(dest_len){
			src_len--; /* exclude BOM */
			src++; /* remove BOM */
		}
		*dest = ufunct->realloc(*dest,  ((dest_len + src_len + 1)
                                                * sizeof(Uchar)));

                if(!*dest){
                        ufunct->error = U_ERR_ALLOCATION_FAILED;
                        return NULL;
                }



		while(*src){
			dest[0][dest_len++] = *src++;
		}

		dest[0][dest_len] = 0;
	}

        return *dest;
}

@* Index.