/*2:*/
#line 11 "uni_utf8_to_uc.w"


#include <unicode.h> 

Uchar*
uni_utf8_to_uc(Ufunctions*ufunct,char*src){
Uchar*ret= NULL;
Uchar*old_ret= NULL;
int ret_len= 1;

ufunct->error= U_ERR_NONE;

ret= ufunct->realloc(ret,ret_len*sizeof(Uchar));
if(!ret){
ufunct->error= U_ERR_ALLOCATION_FAILED;
return NULL;
}

ret[0]= 0xFEFF;

while(*src){
unsigned int src_short= *src;

/*3:*/
#line 70 "uni_utf8_to_uc.w"

ret_len++;
old_ret= ret;
ret= ufunct->realloc(ret,ret_len*sizeof(Uchar));
if(!ret){
ufunct->error= U_ERR_ALLOCATION_FAILED;
old_ret[ret_len-2]= 0;
return old_ret;
}
ret[ret_len-1]= 0;


if(src_short<0x20&&src_short!=0x9&&src_short!=0xA&&
src_short!=0xD){
/*4:*/
#line 102 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_ILLEGAL_CHARACTER;

return ret;

/*:4*/
#line 84 "uni_utf8_to_uc.w"
;
}else if(src_short<0x80){
/*6:*/
#line 128 "uni_utf8_to_uc.w"


ret[ret_len-1]= (Uchar)*src++;

/*:6*/
#line 86 "uni_utf8_to_uc.w"
;
}else if(src_short<'\xE0'){
/*7:*/
#line 139 "uni_utf8_to_uc.w"


ret[ret_len-1]= (Uchar)*src++&0x1F;
src_short= *src;
ret[ret_len-1]<<= 6;

/*8:*/
#line 153 "uni_utf8_to_uc.w"

if(src_short<'\xC0'){
ret[ret_len-1]|= (Uchar)*src++&0x3F;
}else{
/*5:*/
#line 114 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_MALFORMED_CHARACTER;

return ret;

/*:5*/
#line 157 "uni_utf8_to_uc.w"
;
}

/*:8*/
#line 145 "uni_utf8_to_uc.w"
;

/*:7*/
#line 88 "uni_utf8_to_uc.w"
;
}else if(src_short<'\xF0'){
/*9:*/
#line 167 "uni_utf8_to_uc.w"


ret[ret_len-1]= (Uchar)*src++&0x0F;
src_short= *src;
ret[ret_len-1]<<= 6;

/*10:*/
#line 187 "uni_utf8_to_uc.w"


if(src_short<'\xC0'){
ret[ret_len-1]|= (Uchar)*src++&0x3F;
src_short= *src;
ret[ret_len-1]<<= 6;
}else{
/*5:*/
#line 114 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_MALFORMED_CHARACTER;

return ret;

/*:5*/
#line 194 "uni_utf8_to_uc.w"
;
}

/*:10*/
#line 173 "uni_utf8_to_uc.w"
;
/*8:*/
#line 153 "uni_utf8_to_uc.w"

if(src_short<'\xC0'){
ret[ret_len-1]|= (Uchar)*src++&0x3F;
}else{
/*5:*/
#line 114 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_MALFORMED_CHARACTER;

return ret;

/*:5*/
#line 157 "uni_utf8_to_uc.w"
;
}

/*:8*/
#line 174 "uni_utf8_to_uc.w"
;

if(0xD7FF<ret[ret_len-1]&&ret[ret_len-1]<0xE000){
/*4:*/
#line 102 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_ILLEGAL_CHARACTER;

return ret;

/*:4*/
#line 177 "uni_utf8_to_uc.w"
;
}else if(ret[ret_len-1]==0xFFFE||ret[ret_len-1]==0xFFFF){
/*4:*/
#line 102 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_ILLEGAL_CHARACTER;

return ret;

/*:4*/
#line 179 "uni_utf8_to_uc.w"
;
}

/*:9*/
#line 90 "uni_utf8_to_uc.w"
;
}else if(src_short<'\xF8'){
/*11:*/
#line 206 "uni_utf8_to_uc.w"

{
unsigned int ucs= 0;

/*12:*/
#line 236 "uni_utf8_to_uc.w"


ucs= (unsigned int)*src++&0x07;
src_short= *src;
ucs<<= 6;

if(src_short<'\xC0'){
ucs|= (unsigned int)*src++&0x3F;
ucs<<= 6;
}else{
/*5:*/
#line 114 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_MALFORMED_CHARACTER;

return ret;

/*:5*/
#line 246 "uni_utf8_to_uc.w"
;
}

if(src_short<'\xC0'){
ucs|= (unsigned int)*src++&0x3F;
ucs<<= 6;
}else{
/*5:*/
#line 114 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_MALFORMED_CHARACTER;

return ret;

/*:5*/
#line 253 "uni_utf8_to_uc.w"
;
}

if(src_short<'\xC0'){
ucs|= (unsigned int)*src++&0x3F;
}else{
/*5:*/
#line 114 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_MALFORMED_CHARACTER;

return ret;

/*:5*/
#line 259 "uni_utf8_to_uc.w"
;
}

/*:12*/
#line 210 "uni_utf8_to_uc.w"
;

if(ucs> 0x10FFFF){
/*5:*/
#line 114 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_MALFORMED_CHARACTER;

return ret;

/*:5*/
#line 213 "uni_utf8_to_uc.w"
;
}

ret[ret_len-1]= ((ucs-0x010000)/0x0400)+0xD800;

ret_len++;
old_ret= ret;
ret= ufunct->realloc(ret,ret_len*sizeof(Uchar));
if(!ret){
ufunct->error= U_ERR_ALLOCATION_FAILED;
old_ret[ret_len-2]= 0;
return old_ret;
}
ret[ret_len-1]= 0;

ret[ret_len-1]= ((ucs-0x010000)%0x0400)+0xDC00;

}

/*:11*/
#line 92 "uni_utf8_to_uc.w"
;
}else{
/*4:*/
#line 102 "uni_utf8_to_uc.w"


ret[ret_len-1]= 0;
ufunct->error= U_ERR_ILLEGAL_CHARACTER;

return ret;

/*:4*/
#line 94 "uni_utf8_to_uc.w"
;
}

/*:3*/
#line 34 "uni_utf8_to_uc.w"
;

}

old_ret= ret;
ret= ufunct->realloc(ret,(ret_len+1)*sizeof(Uchar));
if(!ret){
ufunct->error= U_ERR_ALLOCATION_FAILED;
old_ret[ret_len-1]= 0;
return old_ret;
}
ret[ret_len]= 0;

return ret;
}

/*:2*/
